options.defaultValue("Skin") = "Green";
options.defaultValue("opacity") = true;
options.defaultValue("human") = 2;
options.defaultValue("no_cpu") = false;

googleTalk.onReceiveTalkData = OnReceiveTalkData;
var dir = "images/";
strDir = 'red/'
var width = 8;
var height = 8;
var	EMPTY = 0;
var	WHITE = 1;
var	BLACK = 2;
var	WHITETRANS = 3;
var	BLACKTRANS = 4;
var	NUMBASE = 5;
var no_cpu = options("no_cpu");
var ss=false;

var	human = BLACK;
var multiplayer = false;
var	weightsquares = 1;
var	edgesensitive = 1;
var friend_user_id;
var	picture = new Array();
var	board = new Array(width);
var	score = new Array();
var	turn = BLACK;
var	AI_timerID;

var lastlookup = 0;

picture[WHITE] = 'white.png';
picture[BLACK] = 'black.png';
picture[EMPTY] = 'blank.png';
picture[WHITETRANS] = 'white_over.png';
picture[BLACKTRANS] = 'black_over.png';
FirstLoad();
var im = new Array();

for(var i=1;i<12;i++){
	im[i] = framework.graphics.loadImage('animate/a'+i+'.png');
}
function FirstLoad()
{

for(var i = 0; i < width; i++)
	board[i] = new Array (height);
	
SwitchSkin(options("Skin"));
human = options("human");
imgBase.opacity=(options("opacity"))?190:255;
	
for(var j=0;j<height;j++)
{
	for(var i=0;i<width;i++)
	{
		if((i == 3 && j == 3) || (i == 4 && j == 4)) player = WHITE;
	    else if((i == 3 && j == 4) || (i == 4 && j == 3)) player = BLACK;
	    else player = EMPTY;
		Base.appendElement('<button name="c['+i+','+j+']" onclick="PutPiece(' + i + ', ' + j + ');" onmouseout="RestorePiece(' + i + ', ' + j + ')" onmouseover="CheckPutPiece('+i+', '+j+')" image="'+picture[player]+'" x="'+Number((j*30)+j)+'" y="'+Number((i*30)+i)+'" />');
		
		board[i][j] = new piece('c[' + i + ',' + j + ']');
	    board[i][j].player = player;
	}

}
    score[WHITE] = 2;
    score[BLACK] = 2;

Play();
SetScore();
}
function rG()
{
ResetBoard(); Play();SetScore();
}
function SB()
{
if(ss) return false;
Buttons.visible = true;
Score.visible = false;
}
function HB()
{
if(ss) return false;
Buttons.visible = false;
Score.visible = true;
}
function ResetBoard() {

    if(AI_timerID != undefined) {
		view.clearInterval(AI_timerID);
		AI_timerID = undefined;
    }

    for(y = 0; y < height; y++) {
	for(x = 0; x < width; x++) {
	    board[x][y].player = EMPTY;
	    SetPieceImage(x, y, picture[EMPTY]);
	}
    }

    score[WHITE] = 0;
    score[BLACK] = 0;

    RawPutPiece(3, 3, WHITE);
    RawPutPiece(4, 4, WHITE);
    RawPutPiece(3, 4, BLACK);
    RawPutPiece(4, 3, BLACK);

    turn = BLACK;
}

function SetScore(){

	if(score[WHITE]<10){
		scoreW1.src='num/blank.png';
		scoreW2.src='num/'+score[WHITE]+'.png';
	}else{
		scoreW1.src='num/'+Math.floor(score[WHITE]/10)+'.png';
		scoreW2.src='num/'+(score[WHITE] % 10)+'.png';
	}
	
	if(score[BLACK]<10){
		scoreB1.src='num/blank.png';
		scoreB2.src='num/'+score[BLACK]+'.png';
	}else{
		scoreB1.src='num/'+Math.floor(score[BLACK]/10)+'.png';
		scoreB2.src='num/'+(score[BLACK] % 10)+'.png';
	}
}


function PutPiece(x, y) {
    if(! CanPutPiece(x, y, human)) return;

    FlipPieces(x, y, human);
	if(multiplayer){
	try {
		googleTalk.SendTalkData(friend_user_id, "action:"+x+","+y);
	} catch (e) {
		alert("Error : \nConnection lost. Google Talk can not send the data. Please try again or click Disconnect Button.");

	}
		
	}
		DoneTurn();
}

function PCMove(player) {
    var x, y;
    var best = 0, numbest = 0;
    var rating;
    var pick, count;

    CalcFlipCounts();

    for(y = 0; y < height; y++) {
	for(x = 0; x < width; x++) {
	    rating = Rate(x, y, player);
	    board[x][y].value[player] = rating;

	    if(rating == best)
		numbest++;
	    else if(rating > best) {
		best = rating;
		numbest = 1;
	    }
	}
    }

    while(numbest > 0) {
	pick = Math.floor(Math.random() * numbest);
	count = 0;
	for(y = 0; y < height; y++) {
	    for(x = 0; x < width; x++) {
		rating = board[x][y].value[player];
		if(rating == best) {
		    if(count == pick) {
			FlipPieces(x, y, player);
			DoneTurn();
			return;
		    }
		    else count++;
		}
	    }
	}
    }
    DoneTurn();
}
function DoneTurn() {
    var moves = AnyMoves(turn);

   

    turn = OtherPlayer(turn);
    if(! AnyMoves(turn)) {
		if(! moves) return(GameOver());
		turn = OtherPlayer(turn);
    }

    if(turn != human && !multiplayer) 
		AI_timerID = setTimeout("PCMove(" + turn + ")", 150);
    
	SetScore();
}


function Rate(x, y, player) {
    var rating;

    if(board[x][y].player != EMPTY) return(0);
    if(x < 0 || x >= width || y < 0 || y >= height) return(0);

    rating = board[x][y].flips[player];

    if(! weightsquares)
		rating = (rating > 0)? 1: 0;

    if(edgesensitive && rating > 0) {
		rating += 10;
		if(x == 0 || x == width - 1) rating += 4;
		if(y == 0 || y == height - 1) rating += 4;
		if(x == 1 || x == width - 2) rating -= 5;
		if(y == 1 || y == height - 2) rating -= 5;

		if(rating < 1) rating = 1;
    }
    return(rating);
}


function CalcFlipCounts() {
    var x, y;

    for(y = 0; y < height; y++) {
	for(x = 0; x < width; x++) {
	    board[x][y].flips[WHITE] = 0;
	    board[x][y].flips[BLACK] = 0;

	    if(board[x][y].player != EMPTY) continue;

	    board[x][y].flips[WHITE] = NumFlips(x, y, WHITE);
	    board[x][y].flips[BLACK] = NumFlips(x, y, BLACK);
	}
    }
}

function GameOver() {
  //  alert("Game Over; White: " + score[WHITE] + ", Black: " + score[BLACK]);
	overG.visible=true;
	if((human==WHITE && score[WHITE]>score[BLACK]) || (human==BLACK && score[WHITE]<score[BLACK])){
		gWin.visible=true;
		gLost.visible=false;
	}else{
		gWin.visible=false;
		gLost.visible=true;
	}
	SetScore();
    turn = EMPTY;
	friend_user_id = '';
	multiplayer=false;
	btnMultiplayer.visible=true;
	btnDisconnect.visible=false;
	human = options("human");
	btnRestart.enabled = true;
}


function AnyMoves(player) {
    var x, y;

    for(y = 0; y < height; y++) {
	for(x = 0; x < width; x++) {
	    if(board[x][y].player != EMPTY) continue;
	    if(NumFlips(x, y, player) > 0) return(true);
	}
    }
    return(false);
}

function FlipPieces(x, y, player) {
    var deltax, deltay, distance;
    var posx, posy;
    var count = 0;
	x=Number(x);
	y=Number(y);
    RawPutPiece(x, y, player);

    for(deltay = -1; deltay <= 1; deltay++) {
	for(deltax = -1; deltax <= 1; deltax++) {
	    for(distance = 1;; distance++) {
		posx = x + (distance * deltax);
		posy = y + (distance * deltay);
		if(posx < 0 || posx >= width || posy < 0 || posy >= height)
		    break;
		if(board[posx][posy].player == EMPTY)
		    break;
		if(board[posx][posy].player == player) {
		    for(distance--; distance > 0; distance--) {
			posx = x + (distance * deltax);
			posy = y + (distance * deltay);
			RawPutPiece(posx, posy, player);
		    }
		    break;
		}
	    }
	}
    }
    return(count);
}

function RawPutPiece(x, y, player) {
    var other = OtherPlayer(player);
    if(board[x][y].player == other) score[other]--;
	
    board[x][y].player = player;
    SetPieceImage(x, y, picture[player]);
    score[player]++;
}

function OtherPlayer(player) {
    return((player == WHITE)? BLACK: WHITE);
}


function SetPieceImage(x, y, src) {
    if(Base.children(board[x][y].imagenum).image != src) {
	if(src=='black.png' && !no_cpu) 
		var drim = beginAnimation( "animate_to_black("+board[x][y].imagenum+",'"+src+"')", 12, 1, 200);
	else if(src=='white.png' && !no_cpu) 
		var drims = beginAnimation( "animate_to_white("+board[x][y].imagenum+",'"+src+"')", 1, 12, 200);
	else
		Base.children(board[x][y].imagenum).image = src;
    }
}


function SetOverPieceImage(x, y, src) {
    if(Base.children(board[x][y].imagenum).image != src) {
		Base.children(board[x][y].imagenum).image = src;
	}
}

function animate_to_black(im,src)
{	
	imNum = Math.round( event.value );
	Base.children(im).image = 'animate/a'+imNum+'.png';
	if(imNum==1)
		Base.children(im).image = src;
}
function animate_to_white(im,src)
{
	imNum = Math.round( event.value );
	Base.children(im).image = 'animate/a'+imNum+'.png';
	if(imNum==12)
		Base.children(im).image = src;
}


function RestorePiece(x, y) {
    SetOverPieceImage(x, y, picture[board[x][y].player]);
}



function RawShowFlipCount(x, y, player) {
    var flips;
    if(board[x][y].player != EMPTY) return(false);
    if((flips = board[x][y].flips[player]) == 0) return(false);
    SetPieceImage(x, y, picture[NUMBASE + flips]);
    return(true);
}



function CheckPutPiece(x, y) {
    var over;

    if(! CanPutPiece(x, y, human)) return;

    if(human == WHITE) over = WHITETRANS;
    else over = BLACKTRANS;

    SetOverPieceImage(x, y, picture[over]);
}



function CanPutPiece(x, y, player) {
    if(turn != player)
	return(false);
    if(board[x][y].player != EMPTY)
	return(false);
    return(NumFlips(x, y, player) > 0);
}


function NumFlips(x, y, player) {
    var deltax, deltay, distance;
    var posx, posy;
    var count = 0;

    for(deltay = -1; deltay <= 1; deltay++) {
	for(deltax = -1; deltax <= 1; deltax++) {
	    for(distance = 1;; distance++) {
		posx = x + (distance * deltax);
		posy = y + (distance * deltay);
		if(posx < 0 || posx >= width || posy < 0 || posy >= height)
		    break;
		if(board[posx][posy].player == EMPTY)
		    break;
		if(board[posx][posy].player == player) {
		    count += distance - 1;
		    break;
		}
	    }
	}
    }
    return(count);
}




function piece(imagename) {
    this.imagenum = lookup(imagename);
    this.player = EMPTY;
    this.flips = new Array();
    this.flips[WHITE] = 0;
    this.flips[BLACK] = 0;
    this.value = new Array();
    this.value[WHITE] = 0;
    this.value[BLACK] = 0;
}

function lookup(name) {
    for(i = lastlookup; i < Base.children.count; i++)
        if(Base.children(i).name == name) { lastlookup = i; return(i); }
    for(i = 0; i < lastlookup; i++)
        if(Base.children(i).name == name) { lastlookup = i; return(i); }
    return(-1);
}



function Play() {
    if(human != BLACK && !multiplayer)
		PCMove(BLACK);
}